Attribute VB_Name = "Mod3DVB"
Declare Function BitBlt Lib "gdi32" (ByVal hDestDC As Long, ByVal X As Long, ByVal Y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hSrcDC As Long, ByVal xSrc As Long, ByVal ySrc As Long, ByVal dwRop As Long) As Long
Declare Function FloodFill Lib "gdi32" (ByVal hdc As Long, ByVal X As Long, ByVal Y As Long, ByVal crColor As Long) As Long
Declare Function ExtFloodFill Lib "gdi32" (ByVal hdc As Long, ByVal X As Long, ByVal Y As Long, ByVal crColor As Long, ByVal wFillType As Long) As Long
Declare Function MoveToEx Lib "gdi32" (ByVal hdc As Long, ByVal X As Long, ByVal Y As Long, lpPoint As POINTAPI) As Long
Declare Function LineTo Lib "gdi32" (ByVal hdc As Long, ByVal X As Long, ByVal Y As Long) As Long

Public Const SRCAND = &H8800C6  ' (DWORD) dest = source AND dest
Public Const SRCCOPY = &HCC0020 ' (DWORD) dest = source
Public Const SRCERASE = &H440328        ' (DWORD) dest = source AND (NOT dest )
Public Const SRCINVERT = &H660046       ' (DWORD) dest = source XOR dest
Public Const SRCPAINT = &HEE0086        ' (DWORD) dest = source OR dest

Public X(50) As Single 'Array containing the X coordinate of the Polygon vertex
Public Y(50) As Single 'Array containing the Y coordinate of the Polygon vertex

Public Type POINTAPI
  X As Integer
  Y As Integer
End Type

Public Type tVector3D
  X As Integer
  Y As Integer
  Z As Integer
End Type

Public Type Vertex
  X As Single
  Y As Single
  Z As Single
End Type

Type tRGBcolor
  R As Byte
  G As Byte
  B As Byte
End Type

Public Type tPolygon4Point
  P3D(1 To 4) As tVector3D
  P2D(1 To 4) As POINTAPI
  Color As Long
End Type

Public Type tObject6Face
  P3D(1 To 12) As tVector3D
  P2D(1 To 12) As POINTAPI
  Color(1 To 12) As Long
End Type

Public Sine(0 To 361) As Double
Public Cosine(0 To 361) As Double
Public FCount As Integer
Public Camera As tVector3D
Public TempColor As Long
Public TempRGBcolor As tRGBcolor
Public p As POINTAPI
Public TempP3D As tVector3D
Public DemoType As Byte
'types of demo
Public Const CUBE_WIREFRAME = 0
Public Const CUBE_FILLED = 1
Public Const CUBE_LIGHTED = 2

Public Const PI = 3.14159265358979 'obvious
Public Const CX = 200
Public Const CY = 200

Public Sub RotateAboutX(Angle)

'rotate about X-axis
For i = 1 To 4
tempY = (Point(i).Y * Cosine(Angle / 180 * PI)) - (Point(i).Z * Sine(Angle / 180 * PI))
Point(i).Z = (Point(i).Y * Sine(Angle / 180 * PI)) - (Point(i).Z * Cosine(Angle / 180 * PI))
'copy new point
Point(i).Y = tempY

'rotate on y-axis
'TempP3D.Z = (p.Z * Cosine(Y)) - (p.X * Sine(Y))
'p.X = (p.X * Cosine(Y)) + (p.Z * Sine(Y))
'copy new point
'p.Z = TempP3D.Z

End Sub


Public Sub RotatePoint(p As tVector3D, X, Y)

'rotate on x-axis
TempP3D.Y = (p.Y * Cosine(X)) - (p.Z * Sine(X))
p.Z = (p.Z * Cosine(X)) + (p.Y * Sine(X))
'copy new point
p.Y = TempP3D.Y

'rotate on y-axis
TempP3D.Z = (p.Z * Cosine(Y)) - (p.X * Sine(Y))
p.X = (p.X * Cosine(Y)) + (p.Z * Sine(Y))
'copy new point
p.Z = TempP3D.Z

End Sub

Public Sub RotatePointX(p As tVector3D, rotation As Integer)
'rotate on x-axis
TempP3D.Y = (p.Y * Cosine(rotation)) - (p.Z * Sine(rotation))
p.Z = (p.Z * Cosine(rotation)) + (p.Y * Sine(rotation))
'copy new point
p.Y = TempP3D.Y

End Sub

Public Sub RotatePointY(p As tVector3D, rotation As Integer)
'rotate on y-axis
TempP3D.Z = (p.Z * Cosine(rotation)) - (p.X * Sine(rotation))
p.X = (p.X * Cosine(rotation)) + (p.Z * Sine(rotation))
'copy new point
p.Z = TempP3D.Z

End Sub

Public Sub RotatePointZ(p As tVector3D, rotation As Integer)

'rotate on z-axis
p.X = (p.X * Cosine(rotation)) - (p.Y * Sine(rotation))
p.Y = (p.Y * Cosine(rotation)) + (p.X * Sine(rotation))

End Sub


Public Sub PlotPoint(p As tVector3D, ScrP As POINTAPI)
'this converts a 3D co-ord to 2D co-ord to be plotted on the screen
On Error Resume Next
LensDivDistance = 256 / (p.Z - Camera.Z)
ScrP.X = (p.X * LensDivDistance) + 200
ScrP.Y = 200 - (p.Y * LensDivDistance)
End Sub

